<?php
namespace Qiniu\Processing;

use Qiniu\Config;
use Qiniu\Http\Client;
use Qiniu\Http\Error;
use Qiniu\Processing\Operation;

/**
 * ־û,첽־û.
 *
 * @link http://developer.qiniu.com/docs/v6/api/reference/fop/pfop/pfop.html
 */
final class PersistentFop
{
    /**
     * @var ˺ŹԿԣAuth
     */
    private $auth;

    /**
     * @var Դڿռ
     */
    private $bucket;

    /**
     * @var ý崦У https://portal.qiniu.com/mps/pipeline
     */
    private $pipeline;

    /**
     * @var ־û֪ͨURL
     */
    private $notify_url;

    /**
     * @var boolean ǷǿƸеļ
     */
    private $force;


    public function __construct($auth, $bucket, $pipeline = null, $notify_url = null, $force = false)
    {
        $this->auth = $auth;
        $this->bucket = $bucket;
        $this->pipeline = $pipeline;
        $this->notify_url = $notify_url;
        $this->force = $force;
    }

    /**
     * Դļ첽־û
     *
     * @param $key   Դļ
     * @param $fops  string|array  pfoppfoparrayʽ롣
     *                eg. avthumb/mp3/ab/192k, vframe/jpg/offset/7/w/480/h/360
     *
     * @return array س־ûpersistentId, ͷصĴ
     *
     * @link http://developer.qiniu.com/docs/v6/api/reference/fop/
     */
    public function execute($key, $fops)
    {
        if (is_array($fops)) {
            $fops = implode(';', $fops);
        }
        $params = array('bucket' => $this->bucket, 'key' => $key, 'fops' => $fops);
        \Qiniu\setWithoutEmpty($params, 'pipeline', $this->pipeline);
        \Qiniu\setWithoutEmpty($params, 'notifyURL', $this->notify_url);
        if ($this->force) {
            $params['force'] = 1;
        }
        $data = http_build_query($params);
        $url = Config::API_HOST . '/pfop/';
        $headers = $this->auth->authorization($url, $data, 'application/x-www-form-urlencoded');
        $headers['Content-Type'] = 'application/x-www-form-urlencoded';
        $response = Client::post($url, $data, $headers);
        if (!$response->ok()) {
            return array(null, new Error($url, $response));
        }
        $r = $response->json();
        $id = $r['persistentId'];
        return array($id, null);
    }

    public static function status($id)
    {
        $url = Config::API_HOST . "/status/get/prefop?id=$id";
        $response = Client::get($url);
        if (!$response->ok()) {
            return array(null, new Error($url, $response));
        }
        return array($response->json(), null);
    }
}
